/* SPDX-License-Identifier: BSD-3-Clause */

/**
 * @file
 * @copyright Copyright (C) 2011 Engineering Design Team, Inc.
 */
#ifndef EDT_OS_LINUX_H
#define EDT_OS_LINUX_H

#ifndef _GNU_SOURCE
// TODO : Replace with just `_POSIX_C_SOURCE 200809L` to no longer enable
// BSD types (pci_driver #13)
#define _GNU_SOURCE
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <limits.h>
#include <stdint.h>
#include <errno.h>

#include <dirent.h>
#include <semaphore.h>
#include <sys/types.h>  // TODO: remove (pci_driver#13)
#include <sys/user.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned int uint_t;
typedef unsigned char uchar_t;
typedef unsigned short ushort_t;

/* utility helpers */

#ifndef TRUE
#define TRUE  (1)
#define FALSE (0)
#endif

typedef int HANDLE;

#define DIRHANDLE   DIR*
#define NULL_HANDLE ((HANDLE)-1)

#ifndef PAGE_SIZE
#include <unistd.h>
#define PAGE_SIZE getpagesize()
#endif

#define PAGESIZE    PAGE_SIZE
#define SECTOR_SIZE PAGE_SIZE

#define MAX_PATH _POSIX_PATH_MAX

#ifdef __cplusplus
}
#endif

#endif /* EDT_OS_LINUX_H */
