/* SPDX-License-Identifier: BSD-3-Clause */

/**
 * @file
 * @copyright Copyright (C) 2011 Engineering Design Team, Inc.
 */
#ifndef EDT_SI570_REGS_H
#define EDT_SI570_REGS_H

#include "lib_two_wire.h"

#ifdef __cplusplus
extern "C" {
#endif

/* timing specific values */
typedef struct si570_info {
  int n1;
  int hs_div;
  int rfreq_hi;
  int rfreq_fraction;
} EdtSI570;

/* description of all register values */
extern const EdtRegisterDescriptor SI570_REGS_MAP[];

EDTAPI void edt_si570_read_values(EdtDev edt_p, u_int base_desc, u_int device, EdtSI570* sip);

EDTAPI void edt_si570_write_values(EdtDev edt_p, u_int base_desc, u_int device, EdtSI570* sip);

EDTAPI int edt_si570_dump(EdtDev edt_p, u_int base_desc, u_int device);

EDTAPI void edt_si570_print(EdtSI570* sip, double refclock);

EDTAPI double edt_vco_si570_compute(double xtal, double target, EdtSI570* parms);

EDTAPI void edt_si570_reset(EdtDev edt_p, u_int base_desc, u_int device);

EDTAPI int edt_si570_set_clock(EdtDev edt_p,
                               u_int base_desc,
                               u_int device,
                               double nominal,
                               double target,
                               EdtSI570* parms);

EDTAPI double edt_si570_get_clock(EdtDev edt_p,
                                  u_int base_desc,
                                  u_int device,
                                  double nominal,
                                  EdtSI570* parms);

#ifdef __cplusplus
}
#endif

#endif /* EDT_SI570_REGS_H */
